// DfCom.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include "DfCom.h"
#include "Setup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <direct.h>
#include <IO.H>
//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//

/////////////////////////////////////////////////////////////////////////////
// CDfComApp

BEGIN_MESSAGE_MAP(CDfComApp, CWinApp)
	//{{AFX_MSG_MAP(CDfComApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDfComApp Konstruktion

CDfComApp::CDfComApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/**
 * @brief Sicherstellen dasz die Anfrage und das Kanalobjekt in Ordnung sind.
 */
bool CDfComApp::ChannelRequest(int ChannelNum)
{
	// Kanalbereich pruefen und evntl. erstellen des nicht vorhandenen Kanalobjektes.
	if (ChannelNum < 0 || ChannelNum >= MAX_CHANNEL) {
		
		// Bereich falsch
		return false;
	}

	// Kanalobjekt bereits vorhanden?
	if (ComArray[ChannelNum] != NULL) {
	
		return true;
	}

	// Kanalobjekt erzeugen
	ComArray[ChannelNum] = new CCom(ChannelNum);

	return true;
}

/**
 * @brief Erhalt eines Kanalobjekts oder NULL bei Bereichsueberschreitung sowie Fehler.
 */
CCom *CDfComApp::GetCom(int Num)
{
	if (ChannelRequest(Num)) {
		
		return ComArray[Num];
	}

	return NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CDfComApp-Objekt

CDfComApp theApp;

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetErrorText"
// Exportierte Funktionen
extern "C" __declspec(dllexport) 

void __stdcall TBCGetErrorText(int ErrNo, char *Text, int Length)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(CHANNEL_0);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) 
	{	
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ErrNo);

	// berprfung der Parameterwerte.
	if (Text == NULL ) {
		
		Com->logEnd("\t\t%i", Length);
		return;
	}

	switch(ErrNo) {
	case ERR_NO_TB:
		_snprintf(Text, Length, "Timeboy antwortet nicht");
		break;
	case ERR_OPEN:
		_snprintf(Text, Length, "Datei kann nicht geoeffnet werden");
		break;
	case ERR_CRC:
		_snprintf(Text, Length, "CRC Fehler in einem Datensatz");
		break;
	case ERR_FORMAT:
		_snprintf(Text, Length, "Fehler im Format der Setup-Datei");
		break;
	case ERR_KOM:
		_snprintf(Text, Length, "Fehler bei Kommunikation mit Timeboy");
		break;
	case ERR_NO_COM:
		_snprintf(Text, Length, "Schnittstelle ist nicht geoeffnet");
		break;
	case ERR_NO_LIST:
		_snprintf(Text, Length, "Keine Listen im DLL Buffer vorhanden");
		break;
	case ERR_NO_DOCK:
		_snprintf(Text, Length, "Dockingstation antwortet nicht");
		break;
	case ERR_PASSWORT:
		_snprintf(Text, Length, "Passwort falsch");
		break;
	case ERR_ABORT:
		_snprintf(Text, Length, "Durchfuehrung wurde von Anwendung abgebrochen");
		break;
	case ERR_BAUDRATE:
		_snprintf(Text, Length, "Baudrate fuer serielle Schnittstelle falsch");
		break;
	case ERR_CHANNEL:
		_snprintf(Text, Length, "Kanalobjekt konnte nicht erstellt oder ermittelt werden.");
		break;
	case ERR_LISTEN_LOESCHEN:
		_snprintf(Text, Length, "Fehler beim lschen der Listendaten.");
		break;
	case ERR_KONFIG_SIZE:
		_snprintf(Text, Length, "Konfigdaten zu gro fr die Firmware.");
		break;
	case ERR_ALT_SETUP:
		_snprintf(Text, Length, "Es wird versucht eine alte Setupdatei in ein Gert mit Firmware >= 3.2 zu laden.");
		break;
	default:
		_snprintf(Text, Length, "Unbekannter Fehler");
		break;
	}

	Com->logEnd("\t%s\t%i", Text, Length);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCComInit"
//**********************************************************************************************
// TBCComInit
//
// Serial-Schnittstelle zum Timeboy initialisieren
// ComNum -> Nr. der Schnittstelle; 1 -> COM1; 2 -> COM2 ...
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK
extern "C" __declspec(dllexport) 

int __stdcall TBCComInit(int ComNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	char ComPort[14];
	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(CHANNEL_0);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) 
	{
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ComNum);

	sprintf(ComPort, "COM%d", ComNum);
	Com->SetFunkOff();
	Com->SetZigBeeOff();

	iRes = Com->ComOpenSerial(ComPort, 9600, 1000);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCComInit38400"
//**********************************************************************************************
// TBCComInit38400
//
// Serial-Schnittstelle zum Timeboy initialisieren mit 38400 Baud
// ComNum -> Nr. der Schnittstelle; 1 -> COM1; 2 -> COM2 ...
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK
extern "C" __declspec(dllexport) 

int __stdcall TBCComInit38400(int ComNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	char ComPort[14];
	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(CHANNEL_0);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) 
	{
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ComNum);

	sprintf(ComPort, "COM%d", ComNum);
	Com->SetFunkOff();
	Com->SetZigBeeOff();
	
	iRes = Com->ComOpenSerial(ComPort, 38400, 1000);
	
	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCComOpen"
//**********************************************************************************************
// TBCComOpen
//
// Socket-Schnittstelle zum Timeboy initialisieren
// String mit der Adresse des W+T Umsetzers z.B. "192.168.0.197"
// Return	0 -> Fehler 
//			1 -> OK
extern "C" __declspec(dllexport) 

int __stdcall TBCComOpen(char *remoteIP)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(CHANNEL_0);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) 
	{
		return iRes;
	}
	Com->logBegin("%s\t%s", FUNC_NAME, remoteIP);

	// berprfung der Parameterwerte.
	if (remoteIP == NULL ) {
		
		Com->logEnd("\t(%i)", iRes);
		return iRes;
	}

	Com->SetFunkOff();
	Com->SetZigBeeOff();

	iRes = Com->ComOpenSocket(remoteIP, 8000, 3000);
	
	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCCheckTBExt"
//**********************************************************************************************
// TBCCheckTBExt
//
// Prfen ob Timeboy in Dockingstation vorhanden ist
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist oder kein Timeboy in der Dock. vorhanden ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Es ist ein Timeboy in der Dockingstation
//				0 -> Es ist kein Timeboy in der Dockingstation oder es ist ein Fehler aufgetreten -> Error auswerten
extern "C" __declspec(dllexport) 

int __stdcall TBCCheckTBExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL ) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TbCheckDeviceDefault(BusNum, Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCCheckTB(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCCheckTBExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCCheckTBExtFast"
//**********************************************************************************************
// TBCCheckTBExtFast
//
// Prfen ob Timeboy in Dockingstation vorhanden ist schnell
// Diese Funktion reagiert schneller als als "TBCCheckTBExt"
// Funktioniert aber nur bei schnellen Verbindungen zuverlssig
// Werden gelegentlich die Timeboy nicht erkannt, sollte die Funktion "TBCCheckTBExt" verwendet werden.
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist oder kein Timeboy in der Dock. vorhanden ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Es ist ein Timeboy in der Dockingstation
//				0 -> Es ist kein Timeboy in der Dockingstation oder es ist ein Fehler aufgetreten -> Error auswerten
extern "C" __declspec(dllexport) 

int __stdcall TBCCheckTBExtFast(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL ) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TbCheckDeviceDefault(BusNum, Error,TRUE);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

// Prfen ob Timeboy in Dockingstation vorhanden ist schnell
// Diese Funktion reagiert schneller als als "TBCCheckTB"
// Funktioniert aber nur bei schnellen Verbindungen zuverlssig
// Werden gelegentlich die Timeboy nicht erkannt, sollte die Funktion "TBCCheckTB" verwendet werden.
extern "C" __declspec(dllexport) 

int __stdcall TBCCheckTBFast(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCCheckTBExtFast(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetZigBeeOnExt"

//**********************************************************************************************
// TBCSetZigBeeOnExt
//
// Kommunikation ber Funk-Umsetzer einschalten
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Alle Befehle arbeiten nach dem Aufruf nur in Verbindung mit Funk
extern "C" __declspec(dllexport) 

void __stdcall TBCSetZigBeeOnExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	Com->SetFunkOn();
	Com->SetZigBeeOn();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetZigBeeOn()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetZigBeeOnExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetFunkOnExt"
//**********************************************************************************************
// TBCSetFunkOnExt
//
// Kommunikation ber Funk-Umsetzer einschalten
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Alle Befehle arbeiten nach dem Aufruf nur in Verbindung mit Funk
extern "C" __declspec(dllexport) 

void __stdcall TBCSetFunkOnExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	Com->SetFunkOn();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetFunkOn()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetFunkOnExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetZigBeeOffExt"
//**********************************************************************************************
// TBCSetZigBeeOffExt
//
// Kommunikation ber Funk-Umsetzer ausschalten
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetZigBeeOffExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);
	
	Com->SetZigBeeOff();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetZigBeeOff()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetZigBeeOffExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetFunkOffExt"
//**********************************************************************************************
// TBCSetFunkOffExt
//
// Kommunikation ber Funk-Umsetzer ausschalten
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetFunkOffExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);
	
	Com->SetFunkOff();
	Com->SetZigBeeOff();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetFunkOff()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetFunkOffExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCNurTbIIOffExt"
//**********************************************************************************************
// TBCNurTbIIOffExt
//
// Timeboy I knnen in Dock. sein
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCNurTbIIOffExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);
	
	Com->NurTbIIOff();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCNurTbIIOff()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCNurTbIIOffExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCNurTbIIOnExt"
//**********************************************************************************************
// TBCNurTbIIOnExt
//
// Nur Timeboy II werden verwendet
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCNurTbIIOnExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);
	
	Com->NurTbIIOn();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCNurTbIIOn()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCNurTbIIOnExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetComCheckBeginEndOnExt"
//**********************************************************************************************
// TBCSetComCheckBeginEndOnExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetComCheckBeginEndOnExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);
	
	Com->SetComCheckBeginEndOn();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetComCheckBeginEndOn()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetComCheckBeginEndOnExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetComCheckBeginEndOffExt"
//**********************************************************************************************
// TBCSetComCheckBeginEndOffExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetComCheckBeginEndOffExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);
	
	Com->SetComCheckBeginEndOff();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetComCheckBeginEndOff()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetComCheckBeginEndOffExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetDockBaudRateExt"
//**********************************************************************************************
// TBCSetDockBaudRateExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockBaudRateExt(int ChannelNum, unsigned char BusNum, int *Error, int BaudRate)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);
	
	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || 
		(BaudRate != 9600 && BaudRate != 19200 && BaudRate != 38400)) {
		
		Com->logEnd("\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, BaudRate, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", BaudRate, *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetDockBaudRate(BusNum, Error, BaudRate);
	Com->ChangeBusNum(MB_ADD_OFFLINE);

	Com->logEnd("\t%i\t%i\t(%i)", BaudRate, *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockBaudRate(unsigned char BusNum, int *Error, int BaudRate)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetDockBaudRateExt(CHANNEL_0, BusNum, Error, BaudRate);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetDockBusNumExt"
//**********************************************************************************************
// TBCSetDockBusNumExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockBusNumExt(int ChannelNum, unsigned char BusNum, int *Error, unsigned char NewBusNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);
	
	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || !((NewBusNum >= 1) && (NewBusNum <= MB_ADD_OFFLINE)) ) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, NewBusNum, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", *Error , NewBusNum, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetDockBusNum(BusNum, Error, NewBusNum);
	Com->ChangeBusNum(MB_ADD_OFFLINE);

	Com->logEnd("\t%i\t%i\t(%i)", *Error, NewBusNum, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockBusNum(unsigned char BusNum, int *Error, unsigned char NewBusNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	return TBCSetDockBusNumExt(CHANNEL_0, BusNum, Error, NewBusNum);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetDockModemStateExt"
//**********************************************************************************************
// TBCSetDockModemStateExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockModemStateExt(int ChannelNum, unsigned char BusNum, int *Error, int State)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, State, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", *Error, State, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetDockModemState(BusNum, Error, State);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%i\t(%i)", *Error, State, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockModemState(unsigned char BusNum, int *Error, int State)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetDockModemStateExt(CHANNEL_0, BusNum, Error, State);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetDockModemStateExt"
//**********************************************************************************************
// TBCGetDockModemStateExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCGetDockModemStateExt(int ChannelNum, unsigned char BusNum, int *Error, int *State)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);


	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || State == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", *Error, *State, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetDockModemState(BusNum, Error, State);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%i\t(%i)", *Error, *State, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetDockModemState(unsigned char BusNum, int *Error, int *State)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCGetDockModemStateExt(CHANNEL_0, BusNum, Error, State);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetDockModemStringExt"
//**********************************************************************************************
// TBCSetDockModemStringExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockModemStringExt(int ChannelNum, unsigned char BusNum, int *Error, char *String)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || String == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%s\t(%i)", ERR_FUNCTION_PARAMETER, (String != NULL) ? String : "", iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%s\t(%i)", *Error, String, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetDockModemString(BusNum, Error, String);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%s\t(%i)", *Error, String, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 
int __stdcall TBCSetDockModemString(unsigned char BusNum, int *Error, char *String)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());
	
	return TBCSetDockModemStringExt(CHANNEL_0, BusNum, Error, String);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetDockModemStringExt"
//**********************************************************************************************
// TBCGetDockModemStringExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCGetDockModemStringExt(int ChannelNum, unsigned char BusNum, int *Error, char *String)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);


	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || String == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%s\t(%i)", *Error, String, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetDockModemString(BusNum, Error, String);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%s\t(%i)", *Error, String, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetDockModemString(unsigned char BusNum, int *Error, char *String)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());
	
	return TBCGetDockModemStringExt(CHANNEL_0, BusNum, Error, String);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetDockTimeOutExt"
//**********************************************************************************************
// TBCSetDockTimeOutExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockTimeOutExt(int ChannelNum, unsigned char BusNum, int *Error, int TimeOut)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, TimeOut, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", *Error, TimeOut, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetDockTimeOut(BusNum, Error, TimeOut);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%i\t(%i)", *Error, TimeOut, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetDockTimeOut(unsigned char BusNum, int *Error, int TimeOut)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());
	
	return TBCSetDockTimeOutExt(CHANNEL_0, BusNum, Error, TimeOut);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetDockTimeOutExt"
//**********************************************************************************************
// TBCGetDockTimeOutExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCGetDockTimeOutExt(int ChannelNum, unsigned char BusNum, int *Error, int *TimeOut)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || TimeOut == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", *Error, *TimeOut, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetDockTimeOut(BusNum, Error, TimeOut);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%i\t(%i)", *Error, *TimeOut, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetDockTimeOut(unsigned char BusNum, int *Error, int *TimeOut)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());
	
	return TBCGetDockTimeOutExt(CHANNEL_0, BusNum, Error, TimeOut);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetVersionExt"
//**********************************************************************************************
// TBCGetVersionExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCGetVersionExt(int ChannelNum, unsigned char BusNum, int *Error, char *Version)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || Version == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%s\t(%i)", *Error, Version, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetVersion(BusNum, Error, Version);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t%s\t(%i)", *Error, Version, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetVersion(unsigned char BusNum, int *Error, char *Version)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleString());
	
	return TBCGetVersionExt(CHANNEL_0, BusNum, Error, Version);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetLogFileNameExt"
//**********************************************************************************************
// TBCSetLogFileNameExt
//
// LogFileName setzen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetLogFileNameExt(int ChannelNum, const unsigned char *LogFileName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (LogFileName == NULL) {
		
		Com->logEnd("\t");
		return;
	}
	

	Com->SetLogFileName(LogFileName);
	Com->logEnd("\t%s", LogFileName);
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetLogFileName(const unsigned char *LogFileName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetLogFileNameExt(CHANNEL_0, LogFileName);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetLogOnExt"
//**********************************************************************************************
// TBCSetLogOnExt
//
// Log ein
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetLogOnExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	Com->SetLogOn();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetLogOn()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetLogOnExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetLogOffExt"
//**********************************************************************************************
// TBCSetLogOffExt
//
// Log aus
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetLogOffExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}

	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	Com->SetLogOff();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetLogOff()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetLogOffExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCCheckDeviceExt"
//**********************************************************************************************
// TBCCheckDeviceExt
//
// Prfen ob Timeboy in Dockingstation vorhanden ist
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist oder kein Timeboy in der Dock. vorhanden ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Es ist ein Timeboy in der Dockingstation
//				0 -> Es ist kein Timeboy in der Dockingstation oder es ist ein Fehler aufgetreten -> Error auswerten
extern "C" __declspec(dllexport) 

int __stdcall TBCCheckDeviceExt(int ChannelNum, int BusNum, int *Error, int DockingPollRetry, int DevicePollRetry)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);
	
	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, DockingPollRetry, DevicePollRetry, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t%i\t(%i)", *Error, DockingPollRetry, DevicePollRetry, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TbCheckDevice(BusNum, Error, DockingPollRetry, DevicePollRetry);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;
	
	Com->logEnd("\t%i\t%i\t%i\t(%i)", *Error, DockingPollRetry, DevicePollRetry, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCCheckDevice(int BusNum, int *Error, int DockingPollRetry, int DevicePollRetry)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCCheckDeviceExt(CHANNEL_0, BusNum, Error, DockingPollRetry, DevicePollRetry);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetDevicePollRetryExt"
//**********************************************************************************************
// TBCGetDevicePollRetryExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCGetDevicePollRetryExt(int ChannelNum, int *DockingPollRetry, int *DevicePollRetry)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (DockingPollRetry == NULL || DevicePollRetry == NULL) {
		
		Com->logEnd("\t\t");
		return;
	}
	

	Com->TbGetDevicePollRetry(DockingPollRetry, DevicePollRetry);
	Com->logEnd("\t%i\t%i", *DockingPollRetry, *DevicePollRetry);
}

extern "C" __declspec(dllexport) 

void __stdcall TBCGetDevicePollRetry(int *DockingPollRetry, int *DevicePollRetry)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCGetDevicePollRetryExt(CHANNEL_0, DockingPollRetry, DevicePollRetry);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCBeginComEx"
//**********************************************************************************************
// TBCBeginComEx
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCBeginComExt(int ChannelNum, unsigned char BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TbBeginCom(BusNum, Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSwitchTimeboyFunkOffExt"

extern "C" __declspec(dllexport) 
//**********************************************************************************************
// TBCSwitchTimeboyFunkOffExt
//
// Funk im Timeboy abschalten
// Die Befehl wird vom Timeboy noch normal abgearbeitet. Danach ist keine Kommunikation 
// mit dem Timeboy ber Funk mehr mglich. Wenn im Timeboy ein Datensatz erzeugt wird, wird der Funk
// wieder eingeschaltet. 
// Eine Weitere Mglichkeit ist ein zeigesteuertes Einschalten.
// Dazu kann im Setup eine Zeitspanne programmiert werden. Whrend die Zeitspanne luft kann der Funk
// trotzdem ber diese DLL-Funktion wieder abgeschaltet werden.
// 
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist oder kein Timeboy in der Dock. vorhanden ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Funktion wurde erfolgreich ausgefhrt
//				0 -> Es ist ein Fehler aufgetreten -> Error auswerten
int __stdcall TBCSwitchTimeboyFunkOffExt(int ChannelNum, unsigned char BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TbSwitchTimeboyFunkOff(BusNum, Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}



extern "C" __declspec(dllexport) 

int __stdcall TBCBeginCom(unsigned char BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCBeginComExt(CHANNEL_0, BusNum, Error);
}

extern "C" __declspec(dllexport) 
//**********************************************************************************************
// TBCSwitchTimeboyFunkOffExt
//
// Funk im Timeboy abschalten
// Beschreibung Siehe Funktion "TBCSwitchTimeboyFunkOffExt"
//
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist oder kein Timeboy in der Dock. vorhanden ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Funktion wurde erfolgreich ausgefhrt
//				0 -> Es ist ein Fehler aufgetreten -> Error auswerten
int __stdcall TBCSwitchTimeboyFunkOff(unsigned char BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSwitchTimeboyFunkOffExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCEndComExt"
//**********************************************************************************************
// TBCEndComExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCEndComExt(int ChannelNum, unsigned char BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TbEndCom(BusNum, Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCEndCom(unsigned char BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCEndComExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetComPortExt"
//**********************************************************************************************
// TBCGetComPortExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

HANDLE __stdcall TBCGetComPortExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return NULL;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	HANDLE h = Com->GetComPort();
	Com->logEnd("\t(%i)", h);
	return h;
}

extern "C" __declspec(dllexport) 

HANDLE __stdcall TBCGetComPort()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCGetComPortExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetComPortExt"
//**********************************************************************************************
// TBCSetComPortExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCSetComPortExt(int ChannelNum, HANDLE ComPort, int PortIsSocket, int BaudRate, int TimeOut, int Radio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i\t%i\t%i\t%i", FUNC_NAME, ChannelNum, ComPort, PortIsSocket, BaudRate, TimeOut, Radio);

	if (Radio) {
		Com->SetZigBeeOff();
		Com->SetFunkOn();
	} else {
		Com->SetFunkOff();
		Com->SetZigBeeOff();
	}

	iRes = Com->SetComPort(ComPort, PortIsSocket, BaudRate, TimeOut);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetComPort(HANDLE ComPort, int PortIsSocket, int BaudRate, int TimeOut, int Radio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetComPortExt(CHANNEL_0, ComPort, PortIsSocket, BaudRate, TimeOut, Radio);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSerialOpenEx"

//**********************************************************************************************
// TBCSerialOpenEx
//
// Serial-Schnittstelle zum Timeboy initialisieren
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK
extern "C" __declspec(dllexport) 

int __stdcall TBCSerialOpenExt(int ChannelNum, char *ComPort, int BaudRate, int TimeOut, int Radio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	int iRes = 0;

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (ComPort == NULL || (BaudRate != 9600 && BaudRate != 19200 && BaudRate != 38400)) {
		
		Com->logEnd("\t%s\t%i\t%i\t%i", (ComPort != NULL) ? ComPort : "", BaudRate, TimeOut, Radio);
		return iRes;
	}
	

	Com->logAppend("\t%s\t%i\t%i\t%i",ComPort, BaudRate, TimeOut, Radio);

	if (Radio) {
		Com->SetZigBeeOff();
		Com->SetFunkOn();
	} else {
		Com->SetFunkOff();
		Com->SetZigBeeOff();
	}

	iRes = Com->ComOpenSerial(ComPort, BaudRate, TimeOut);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSerialOpen(char *ComPort, int BaudRate, int TimeOut, int Radio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSerialOpenExt(CHANNEL_0, ComPort, BaudRate, TimeOut, Radio);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSocketOpenExt"
//**********************************************************************************************
// TBCSocketOpenExt
//
// Socket-Schnittstelle zum Timeboy initialisieren
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Return	0 -> Fehler 
//			1 -> OK
extern "C" __declspec(dllexport) 

int __stdcall TBCSocketOpenExt(int ChannelNum, char *RemoteIP, int PortNo, int TimeOut, int Radio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (RemoteIP == NULL) {
		
		Com->logEnd("\t%s\t%i\t%i\t%i", "", PortNo, TimeOut, Radio);
		return iRes;
	}
	

	Com->logAppend("\t%s\t%i\t%i\t%i", RemoteIP, PortNo, TimeOut, Radio);

	if (Radio) {
		Com->SetZigBeeOff();
		Com->SetFunkOn();
	} else {
		Com->SetFunkOff();
		Com->SetZigBeeOff();
	}
		
	iRes = Com->ComOpenSocket(RemoteIP, PortNo, TimeOut);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSocketOpen(char *RemoteIP, int PortNo, int TimeOut, int Radio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSocketOpenExt(CHANNEL_0, RemoteIP, PortNo, TimeOut, Radio);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCComCloseExt"
//**********************************************************************************************
// TBCComCloseExt
//
// Schnittstelle zum Timeboy schliesen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCComCloseExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());


	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	Com->SetFunkOff();
	Com->SetZigBeeOff();
	Com->ComClose();

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCComClose()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCComCloseExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetupLadenExt"
//**********************************************************************************************
// TBCSetupLadenExt
//
// Setup-Daten aus Datei lesen und in Timeboy bertragen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// DateiName -> Dateinahme der Setup-Datei (wenn notwendug mit Pfad)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCSetupLadenExt(int ChannelNum, int BusNum, char *DateiName, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CFile FSetup;
	int iRes = 0,i,j,Size,Version2=FALSE;
	unsigned char buf[10];

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || DateiName == NULL || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%s\t%i\t(%i)", (DateiName != NULL) ? DateiName : "", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	

	Com->logAppend("\t%s", DateiName);

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	if (!FSetup.Open(DateiName,CFile::modeRead)) {
		*Error = ERR_OPEN;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	// EEP-Daten lesen
	if (FSetup.Read(Com->EepMem,EEP_SIZE) != EEP_SIZE) {
		*Error = ERR_FORMAT;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	// 16kByte Konfigdaten lesen
	if (FSetup.Read(Com->FlashMem,FLASH_SIZE_SU) != FLASH_SIZE_SU) {
		*Error = ERR_FORMAT;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Size = FLASH_SIZE_SU;
	// Hat die Setupdatei 48kByte Konfig?
	if (Com->EepMem[P_SETUP_VERSION] == 2) {
		// Erweiterter Konfigbereich ist vorhanden
		// ListenNamen berlesen
		for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++){
			if (FSetup.Read(buf,1) != 1) {
				*Error = ERR_FORMAT;
				Com->logEnd("\t%i\t(%i)", *Error, iRes);
				return iRes;
			}
			for (j=0;j<buf[0];j++) {
				if (FSetup.Read(&buf[1],1) != 1) {
					*Error = ERR_FORMAT;
					Com->logEnd("\t%i\t(%i)", *Error, iRes);
					return iRes;
				}
			}
		}
		// die restlichen 32kByte Konfigdaten lesen
		if (FSetup.Read(&Com->FlashMem[FLASH_SIZE_SU],FLASH_SIZE_SU_EXT) != FLASH_SIZE_SU_EXT) {
			*Error = ERR_FORMAT;
			Com->logEnd("\t%i\t(%i)", *Error, iRes);
			return iRes;
		}
		// Tatschliche Gre der Konfigdaten ermitteln
		Size = *((int*)(&Com->FlashMem[FLASH_SIZE_SU_V2-4]));
		if (Size > FLASH_SIZE_SU_V2-4) {
			// zur Sicherheit Gre begrenzen
			Size = FLASH_SIZE_SU;
		}
		Version2=TRUE;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetSetup(Error,Size,Version2);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetupLaden(int BusNum, char *DateiName, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetupLadenExt(CHANNEL_0, BusNum, DateiName, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadDatenExt"
//**********************************************************************************************
// TBCLoadDatenExt
//
// Erfasste Daten aus dem Timeboy lesen
// Die Daten werden im PC in einen Buffer abgelegt und knnen mit 
// den Funktionen "TCBDat..." ausgewertet werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadDatenExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	// Daten aus Timeboy lesen
	Com->ChangeBusNum(BusNum);
	if (!Com->GetDaten(Error)) {
		Com->ChangeBusNum(MB_ADD_OFFLINE);
		Com->Abbruch = FALSE;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	// Daten fr Auswertung mit "TCBDat..." vorbereiten
	if (!Com->ScanDaten(Error)) {
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	*Error = ERR_NO;
	iRes = 1;
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadDaten(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadDatenExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCClrDatenExt"
//**********************************************************************************************
// TBCClrDatenExt
//
// Erfasste Daten im Timeboy lschen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCClrDatenExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->ClrDat(Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCClrDaten(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCClrDatenExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadDatensatzbeschreibungExt"
//**********************************************************************************************
// TBCLoadDatensatzbeschreibungExt
//
// Datensatzbeschreibungen aus dem Timeboy lesen
// Die Datensatzbeschreibungen werden im PC in einen Buffer abgelegt und knnen mit 
// den Funktionen "TCBDatB..." ausgewertet werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadDatensatzbeschreibungExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	// Daten aus Timeboy lesen
	Com->ChangeBusNum(BusNum);
	if (!Com->GetDatensatzbeschreibung(Error)) {
		Com->ChangeBusNum(MB_ADD_OFFLINE);
		Com->Abbruch = FALSE;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	*Error = ERR_NO;
	iRes = 1;
	
	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadDatensatzbeschreibung(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadDatensatzbeschreibungExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListDFeldCntExt"
//**********************************************************************************************
// TBCListDFeldCntExt
//
// Anzahl Felder einer zurckgelesenen Liste holen.
// Die Liste mu vorher mit der Funktion "TBCReLoadListExt" oder "TBCReLoadList" aus dem Timeboy gelesen werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Cnt      ->  Anzahl Felder der Liste.
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Liste wurde nicht erfolgreich aus dem Timeboy zurckgelesen. 
extern "C" __declspec(dllexport) 

int __stdcall TBCListDFeldCntExt(int ChannelNum,int *Cnt)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (Cnt == NULL) {
		
		Com->logEnd("\t\t(%i)", iRes);
		return iRes;
	}
	
	iRes = Com->ListDFeldCnt(Cnt);

	Com->logEnd("\t%i\t(%i)", *Cnt, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListDFeldCnt(int *Cnt)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListDFeldCntExt(CHANNEL_0,Cnt);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListDCntExt"
//**********************************************************************************************
// TBCListDCntExt
//
// Anzahl Zeilen einer zurckgelesenen Liste holen.
// Die Liste mu vorher mit der Funktion "TBCReLoadListExt" oder "TBCReLoadList" aus dem Timeboy gelesen werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Cnt      ->  Anzahl Zeilen der Liste.
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Liste wurde nicht erfolgreich aus dem Timeboy zurckgelesen. 
extern "C" __declspec(dllexport) 

int __stdcall TBCListDCntExt(int ChannelNum,int *Cnt)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (Cnt == NULL) {
		
		Com->logEnd("\t\t(%i)", iRes);
		return iRes;
	}

	iRes = Com->ListDCnt(Cnt);

	Com->logEnd("\t%i\t(%i)", *Cnt, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListDCnt(int *Cnt)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListDCntExt(CHANNEL_0,Cnt);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListDGetExt"
//**********************************************************************************************
// TBCListDGetExt
//
// Ein Listenfeld aus einer zurckgelesenen Liste holen.
// Die Liste mu vorher mit der Funktion "TBCReLoadListExt" oder "TBCReLoadList" aus dem Timeboy gelesen werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Zeile    ->  Zeile der Liste aus der gelesen werden soll.
//				0 ist die erste Zeile der Liste
// Feld     ->  Feld innerhalb der Zeile.
//				0 ist das erste Feld in der Listenzeile
// Buf		->  Buffer in den das Feld kopiert wird. 
//				Achtung! die Funktion reserviert keinen Speicher fr Buf. Dies mu vor dem Funktionsaufruf erfolgen.
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Liste wurde nicht erfolgreich aus dem Timeboy zurckgelesen oder 
//							 Zeilennummer bzw. Feldnummer ist ungltig oder ChannelNum ungltig)
extern "C" __declspec(dllexport) 

int __stdcall TBCListDGetExt(int ChannelNum,int Zeile, int Feld, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i", FUNC_NAME, ChannelNum, Zeile, Feld);

	// berprfung der Parameterwerte.
	if (!(Feld >= 0 && Feld < MAX_FELD) || Buf == NULL) {
		
		Com->logEnd("\t\t(%i)", iRes);
		return iRes;
	}
	
	iRes = Com->ListDGet(Zeile,Feld,Buf);

	Com->logEnd("\t%s\t(%i)", Buf, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListDGet(int Zeile, int Feld, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListDGetExt(CHANNEL_0,Zeile,Feld,Buf);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCReLoadListExt"
//**********************************************************************************************
// TBCReLoadListExt
//
// Liste aus Timeboy zurcklesen
// Die Daten der Liste werden im PC in einem Buffer abgelegt und knnen mit 
// den Funktionen "TCBListDGet" geholt werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// ListNr	->  Nummer der Liste die zurckgelesen werden soll
//				0 ist die erste Liste entsprechend der Reihenfolge der Listenbeschreibungen im Setup
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCReLoadListExt(int ChannelNum, int BusNum, int ListNr, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i", FUNC_NAME, ChannelNum, BusNum, ListNr);

	// berprfung der Parameterwerte.
	if (!(ListNr >= 0 && ListNr < MAX_DATENSATZ_BESCHREIBUNG) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	// Daten aus Timeboy lesen
	Com->ChangeBusNum(BusNum);
	if (!Com->GetDatensatzbeschreibung(Error,TRUE,ListNr)) {
		Com->ChangeBusNum(MB_ADD_OFFLINE);
		Com->Abbruch = FALSE;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	*Error = ERR_NO;
	iRes = 1;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCReLoadList(int BusNum, int ListNr, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCReLoadListExt(CHANNEL_0, BusNum, ListNr, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadListenbeschreibungExt"
//**********************************************************************************************
// TBCLoadListenbeschreibungExt
//
// Listenbeschreibungen aus dem Timeboy lesen
// Die Listenbeschreibungen werden im PC in einen Buffer abgelegt und knnen mit 
// den Funktionen "TCBListB..." ausgewertet werden.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadListenbeschreibungExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}
	
	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	// Daten aus Timeboy lesen
	Com->ChangeBusNum(BusNum);
	if (!Com->GetDatensatzbeschreibung(Error,TRUE)) {
		Com->ChangeBusNum(MB_ADD_OFFLINE);
		Com->Abbruch = FALSE;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	*Error = ERR_NO;
	iRes = 1;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadListenbeschreibung(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadListenbeschreibungExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatBCntExt"
//**********************************************************************************************
// TBCDatBCntExt
//
// Anzahl der ausgelesenen Datensatzbeschreibungen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Return	->	Anzahl Datenstze
extern "C" __declspec(dllexport) 

int __stdcall TBCDatBCntExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	iRes = Com->GetDatBCnt();

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCDatBCnt()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatBCntExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListSizeNumExt"
//**********************************************************************************************
// TBCListSizeNumExt
//
// Speichergre fr Listen im Timeboy auslesen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// return -> Nummer die festlegt wie fiel Speicher im Timeboy fr Listen fest und variable 
//           reserviert wird.
//			 Kann fr das Erzeugen von Listen verwendet werden (Parameter "ListMemSizeNum")
//			 0 -> 96kByte Listen
//			 1 -> 224kByte Listen
//			 2 -> 352kByte Listen
//			 3 -> 480kByte Listen
//			 4 -> 608kByte Listen
//			 5 -> 736kByte Listen
//			 6 -> 864kByte Listen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
extern "C" __declspec(dllexport) 

int __stdcall TBCListSizeNumExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	iRes = Com->GetListSizeNum();

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListSizeNum()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListSizeNumExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListSizeNumVExt"
//**********************************************************************************************
// TBCListSizeNumVExt
//
// Speichergre fr variable Listen im Timeboy auslesen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// return -> Nummer die festlegt wie fiel Speicher im Timeboy fr variable Listen  
//           reserviert wird.
//			 Kann fr das Erzeugen von Listen verwendet werden (Parameter "ListMemSizeNumV")
//			 1 -> 128kByte Listen
//			 2 -> 256kByte Listen
//			 3 -> 384kByte Listen
//			 4 -> 512kByte Listen
//			 5 -> 640kByte Listen
//			 6 -> 768kByte Listen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
extern "C" __declspec(dllexport) 

int __stdcall TBCListSizeNumVExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}

	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	iRes = Com->GetListSizeNumV();

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListSizeNumV()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListSizeNumVExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListBCntExt"
//**********************************************************************************************
// TBCListBCntExt
//
// Anzahl der ausgelesenen Listenbeschreibungen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Return	->	Anzahl Datenstze
extern "C" __declspec(dllexport) 

int __stdcall TBCListBCntExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	iRes = Com->GetDatBCnt(TRUE);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListBCnt()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListBCntExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatBDatensatzExt"
//**********************************************************************************************
// TBCDatBDatensatzExt
//
// Daten einer Datensatzbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// Im Timeboy knnen Datenstze mit unterschiedlichem Format gespeichert werden.
// Im Setup-Programm werden die Datenstze uner dem Punkt "Datensatzbeschreibung" festgelegt.
// Die erste Datensatzbeschreibung im Setup-Baum hat die Nummer 0, die zweite die Nummer 1 ...
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// DatBeschreibungNum	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)
// Return	->	1 -> Daten werden in den Var.:"Name" und "Felder" bergeben
//				0 -> Datensatzbeschreibung im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name der Datensatzbeschreibung (Name mu min. 17 Byte haben)
//   Felder -> Anzahl Felder des Datensatzes
extern "C" __declspec(dllexport) 

int __stdcall TBCDatBDatensatzExt(int ChannelNum, int DatBeschreibungNum,unsigned char *Name,int *Felder)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, DatBeschreibungNum);

	// berprfung der Parameterwerte.
	if (!(DatBeschreibungNum >= 0 && DatBeschreibungNum < MAX_DATENSATZ_BESCHREIBUNG) || Name == NULL || Felder == NULL) {
		
		Com->logEnd("\t\t\t(%i)", iRes);
		return iRes;
	}
	
	iRes = Com->GetDatBDatensatz(DatBeschreibungNum,Name,Felder);

	Com->logEnd("\t%s\t%i\t(%i)", Name, *Felder, iRes);	
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCDatBDatensatz(int DatBeschreibungNum,unsigned char *Name,int *Felder)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatBDatensatzExt(CHANNEL_0, DatBeschreibungNum, Name, Felder);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListBDatensatzExt"
//**********************************************************************************************
// TBCListBDatensatzExt
//
// Daten einer Listenbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
// Im Timeboy knnen Listen mit unterschiedlichem Format gespeichert werden.
// Im Setup-Programm werden die Listen uner dem Punkt "Listenbeschreibung" festgelegt.
// Die erste Listenbeschreibung im Setup-Baum hat die Nummer 0, die zweite die Nummer 1 ...
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// ListBeschreibungNum	->	Nummer der Listenbeschreibung (wird ab 0 gezhlt)
// Return	->	1 -> Daten werden in den Var.:"Name","Felder" und "Variable" bergeben
//				0 -> Datensatzbeschreibung im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name der Datensatzbeschreibung (Name mu min. 17 Byte haben)
//   Felder -> Anzahl Felder des Datensatzes
//   Variable -> TRUE -> variable Liste
//				 FALSE -> feste Liste
extern "C" __declspec(dllexport) 

int __stdcall TBCListBDatensatzExt(int ChannelNum, int ListBeschreibungNum,unsigned char *Name,int *Felder,int *Variable)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, ListBeschreibungNum);

	// berprfung der Parameterwerte.
	if (!(ListBeschreibungNum >= 0 && ListBeschreibungNum < MAX_DATENSATZ_BESCHREIBUNG) || Name == NULL || Felder == NULL || Variable == NULL) {
		
		Com->logEnd("\t\t\t\t(%i)", iRes);
		return iRes;
	}
	
	iRes = Com->GetDatBDatensatz(ListBeschreibungNum,Name,Felder,Variable,TRUE);

	Com->logEnd("\t%s\t%i\t%i\t(%i)", Name, *Felder, *Variable, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListBDatensatz(int ListBeschreibungNum,unsigned char *Name,int *Felder,int *Variable)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListBDatensatzExt(CHANNEL_0, ListBeschreibungNum, Name, Felder, Variable);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatBFeldExt"
//**********************************************************************************************
// TBCDatBFeldExt
//
// Daten eines Feldes einer Datensatzbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// DatBeschreibungNum	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)
// Feld -> Feld der Datensatzbeschreibung entsprechend Reihenfolge im Setup (wird ab 0 gezhlt) 
// Return	->	1 -> Daten werden in den Var.:"Name" und "Typ" bergeben
//				0 -> Datensatzbeschreibung oder Feldnummer im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name des Feldes (Name mu min. 17 Byte haben)
//   Typ -> Datentyp des Feldes
//				1	unsigned long 4 Byte 
//				2	Date und Time 7 Byte
//				3	wie Typ 4, es sind jedoch nur Ziffern erlaubt 
//				4	Alpha-Numerisch ASCII
//				5	Datum 4 Byte Y100,Y,M,D 
//				6	Zeit 3 Byte H,Mi,S
//	 Len -> Lnge des Feldes in Byte
//			Bei Typ 3 und 4 wird die anbschliesende "0" mitgezhlt.
//			z.B. ASCII-Feld 15 Zeichen -> Len = 5+1 = 16 Byte
extern "C" __declspec(dllexport) 

int __stdcall TBCDatBFeldExt(int ChannelNum, int DatBeschreibungNum, int Feld, unsigned char *Name,int *Typ,int *Len)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i", FUNC_NAME, ChannelNum, DatBeschreibungNum, Feld);

	// berprfung der Parameterwerte.
	if (!(DatBeschreibungNum >= 0 && DatBeschreibungNum < MAX_DATENSATZ_BESCHREIBUNG) || 
		!(Feld >= 0 && Feld < MAX_FELD) || Name == NULL || Typ == NULL || Len == NULL) {
		
		Com->logEnd("\t\t\t\t(%i)", iRes);
		return iRes;
	}
	

	iRes = Com->GetDatBFeld(DatBeschreibungNum,Feld,Name,Typ,Len);

	Com->logEnd("\t%s\t%i\t%i\t(%i)", Name, *Typ, *Len, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCDatBFeld(int DatBeschreibungNum, int Feld, unsigned char *Name,int *Typ,int *Len)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatBFeldExt(CHANNEL_0, DatBeschreibungNum, Feld, Name, Typ, Len);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCListBFeldExt"
//**********************************************************************************************
// TBCListBFeldExt
//
// Daten eines Feldes einer Listenbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// ListBeschreibungNum	->	Nummer der Listenbeschreibung (wird ab 0 gezhlt)
// Feld -> Feld der Listenbeschreibung entsprechend Reihenfolge im Setup (wird ab 0 gezhlt) 
// Return	->	1 -> Daten werden in den Var.:"Name" und "Typ" bergeben
//				0 -> Listenbeschreibung oder Feldnummer im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name Feldes (Name mu min. 17 Byte haben)
//   Typ -> Datentyp des Feldes
//				1	unsigned long 4 Byte 
//				2	Date und Time 7 Byte
//				3	wie Typ 4, es sind jedoch nur Ziffern erlaubt 
//				4	Alpha-Numerisch ASCII
//				5	Datum 4 Byte Y100,Y,M,D 
//				6	Zeit 3 Byte H,Mi,S
//	 Len -> Lnge des Feldes in Byte
//			Bei Typ 3 und 4 wird die anbschliesende "0" mitgezhlt.
//			z.B. ASCII-Feld 15 Zeichen -> Len = 5+1 = 16 Byte
extern "C" __declspec(dllexport) 

int __stdcall TBCListBFeldExt(int ChannelNum, int ListBeschreibungNum, int Feld, unsigned char *Name,int *Typ,int *Len)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i", FUNC_NAME, ChannelNum, ListBeschreibungNum, Feld);

	// berprfung der Parameterwerte.
	if (!(ListBeschreibungNum >= 0 && ListBeschreibungNum < MAX_DATENSATZ_BESCHREIBUNG) || 
		!(Feld >= 0 && Feld < MAX_FELD) || Name == NULL || Typ == NULL || Len == NULL) {
		
		Com->logEnd("\t\t\t\t(%i)", iRes);
		return iRes;
	}

	iRes = Com->GetDatBFeld(ListBeschreibungNum,Feld,Name,Typ,Len,TRUE);

	Com->logEnd("\t%s\t%i\t%i\t(%i)", Name, *Typ, *Len, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCListBFeld(int ListBeschreibungNum, int Feld, unsigned char *Name,int *Typ,int *Len)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCListBFeldExt(CHANNEL_0, ListBeschreibungNum, Feld, Name, Typ, Len);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatCntExt"
//**********************************************************************************************
// TBCDatCntExt
//
// Anzahl der ausgelesenen Datenstze
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Return	->	Anzahl Datenstze
extern "C" __declspec(dllexport) 

int __stdcall TBCDatCntExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	iRes = Com->GetDatCnt();

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCDatCnt()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatCntExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatBeschreibungNumExt"
//**********************************************************************************************
// TBCDatBeschreibungNumExt
//
// Nummer der Datensatzbeschreibung eines Datensatzes ermitteln
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// Im Timeboy knnen Datenstze mit unterschiedlichem Format gespeichert werden.
// Im Setup-Programm werden die Datenstze uner dem Punkt "Datensatzbeschreibung" festgelegt.
// Die erste Datensatzbeschreibung im Setu-Baum hat die Nummer 0, die zweite die Nummer 1 ...
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// DatNum	->	Nummer des Datensatzes (wird ab 0 gezhlt -> DatNum = 0 -> erster Datensatz)
// Return	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)
extern "C" __declspec(dllexport) 

int __stdcall TBCDatBeschreibungNumExt(int ChannelNum, int DatNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, DatNum);

	// berprfung der Parameterwerte.
	if (DatNum < 0) {
		
		Com->logEnd("\t(%i)", iRes);
		return iRes;
	}

	iRes = Com->GetDatBeschreibungNum(DatNum);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 
int __stdcall TBCDatBeschreibungNum(int DatNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatBeschreibungNumExt(CHANNEL_0, DatNum);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatLenExt"
//**********************************************************************************************
// TBCDatLenExt
//
extern "C" __declspec(dllexport) 

int __stdcall TBCDatLenExt(int ChannelNum, int DatNum)
// Lnge eines Datensatzes ermitteln
// Es wird nur die Lnge der Nutzdaten zurckgegeben (ohne Verwaltungsinformationen und CRC)
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// DatNum	->	Nummer des Datensatzes (wird ab 0 gezhlt -> DatNum = 0 -> erster Datensatz)
// Return	->	Lnge des Datensatzes
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, DatNum);

	// berprfung der Parameterwerte.
	if (DatNum < 0) {
		
		Com->logEnd("\t(%i)", iRes);
		return iRes;
	}

	iRes = Com->GetDatLen(DatNum);

	Com->logEnd("\t(%i)", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCDatLen(int DatNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatLenExt(CHANNEL_0, DatNum);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCDatCopyExt"
//**********************************************************************************************
// TBCDatCopyExt
//
// Datensatz kopieren
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// DatNum	->	Nummer des Datensatzes (wird ab 0 gezhlt -> DatNum = 0 -> erster Datensatz)
// Buf		->	Buffer fr die Daten eines Datensatzes
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler Datensatz nicht vorhanden
extern "C" __declspec(dllexport) 

int __stdcall TBCDatCopyExt(int ChannelNum, int DatNum,unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, DatNum);

	// berprfung der Parameterwerte.
	if (DatNum < 0 || Buf == NULL) {
		
		Com->logEnd("\t\t(%i)", iRes);
		return iRes;
	}

	iRes = Com->CpyDat(DatNum,Buf);

	if (iRes)
	{
		// Daten in Puffer uebergeben
		unsigned char ucTmp[512 * 3 + 1];
		int i, len = Com->GetDatLen(DatNum);

		for (i=0; i < len; i++) {
			
			sprintf((char*)&ucTmp[i * 3], "%02X ", (unsigned char)Buf[i]);
		}
		ucTmp[i * 3] = 0;

		Com->logEnd("\t%s\t(%i)", ucTmp, iRes);

	}
	else
	{
		Com->logEnd("\t\t(%i)", iRes);
	}

	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCDatCopy(int DatNum,unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCDatCopyExt(CHANNEL_0, DatNum, Buf);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCBinToULongMSBFirst"
//**********************************************************************************************
// TBCBinToULongMSBFirst
//
// binre Daten in unsigned long umwandeln 
// Die binre Zahl begin mit dem MSB (Motorola Format)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Buf		->	Buffer der die binre Zahl enthlt 
// Return	->	unsigned long Wert
extern "C" __declspec(dllexport) 

unsigned long __stdcall TBCBinToULongMSBFirst(unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(CHANNEL_0);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, CHANNEL_0);

	// berprfung der Parameterwerte.
	if (Buf == NULL) {
		
		Com->logEnd("\t\t(%i)", iRes);
		return iRes;
	}

	iRes = Com->BinToULongMSBFirst(Buf);

	Com->logEnd("\t0x%08X\t(%i)", Buf, iRes);
	return iRes;
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCMakeListeExt"
//**********************************************************************************************
// TBCMakeListeExt
//
// Daten einer Liste in den Buffer der DLL schreiben
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// ListNum	-> Nummer der Liste entsprechend Listenbeschreibung im Setup (wird ab 0 gezhlt)
// ListCnt	-> Anzahl der Zeilen in der Liste
// ListSize -> Gre der Liste in Byte (ListCnt mal Byte pro Listenzeile)
// Buf		-> Buffer mit den Listendaten
// ListMemSizeNum -> Nummer die festlegt wiefiel Speicher im Timeboy fr Listen reserviert wird
//					 mu mit Angabe im Setup bereinstimmen!
//				  0 -> 96kByte Listen
//				  1 -> 224kByte Listen
//				  2 -> 352kByte Listen
//				  3 -> 480kByte Listen
//				  4 -> 608kByte Listen
//				  5 -> 736kByte Listen
//				  6 -> 864kByte Listen
// return	-> 1 -> Operation erfolgreich
//			-> 0 -> Fehler
extern "C" __declspec(dllexport) 

int __stdcall TBCMakeListeExt(int ChannelNum, int ListNum, int ListCnt, int ListSize, unsigned char *Buf,int ListMemSizeNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i\t%i", FUNC_NAME, ChannelNum, ListNum, ListCnt, ListSize);

	// berprfung der Parameterwerte.
	if (!((ListNum >= 0) && (ListNum < MAX_DATENSATZ_BESCHREIBUNG)) || ((Buf == NULL) && ((ListCnt > 0) || (ListSize > 0)))) {
		
		Com->logEnd("\t\t%i\t(%i)", ListMemSizeNum, iRes);
		return iRes;
	}


	unsigned long pDat,ListStart;
	int i;

	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCMakeListeExt ChannelNum=%04X ListNum=%04X ListCnt=%04X ListSize=%04X ListMemSizeNum=%04X Buf=\r\n",t,ChannelNum,ListNum,ListCnt,ListSize,ListMemSizeNum);
		theApp.LogFile.Write(st,st.GetLength());
		LogWriteHex(Buf,ListSize,&(theApp.LogFile));
	}

	// Startadresse berechnen
	if(ListMemSizeNum == 1) ListStart = FLASH_LIST_START_1;
	else if(ListMemSizeNum == 2) ListStart = FLASH_LIST_START_2;
	else if(ListMemSizeNum == 3) ListStart = FLASH_LIST_START_3;
	else if(ListMemSizeNum == 4) ListStart = FLASH_LIST_START_4;
	else if(ListMemSizeNum == 5) ListStart = FLASH_LIST_START_5;
	else if(ListMemSizeNum == 6) ListStart = FLASH_LIST_START_6;
	else ListStart = FLASH_LIST_START;
	// Pointer in Tabelle der Listen-Pointer eintragen
	*(unsigned long *)(&(Com->FlashMem[ListNum*sizeof(long)+ListStart])) = Com->LSize+ListStart;
	// Start fr Listendaten berechnen
	pDat = Com->LSize+sizeof(ULONG);	// Platz fr Anzahl Eintrge freihalten
	// Startadresse und Gre fr Listen einzeln merken
	Com->SlListStart[ListNum] = Com->LSize+ListStart;
	Com->SlListSize[ListNum] = ListSize+sizeof(ULONG)+32;
	// Listendaten kopieren
	for (i=0;i<ListSize;i++) {
		Com->FlashMem[pDat+i+ListStart] = Buf[i];
	}
	// Anzahl Listenzeilen eintragen
	*(unsigned long*)(&(Com->FlashMem[Com->LSize+ListStart])) = ListCnt;
	// Listen-Pointer auf erstes freies Byte im Listenspeicher setzen
	Com->LSize = pDat+ListSize;
	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCMakeListeExt Exit OK\r\n",t);
		theApp.LogFile.Write(st,st.GetLength());
	}
	iRes = 1;

	/*
	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCMakeListeExt Exit Error\r\n",t);
		theApp.LogFile.Write(st,st.GetLength());
	}
	*/

	Com->logEnd("\t0x%08X\t%i\t(%i)", Buf, ListMemSizeNum, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCMakeListe(int ListNum, int ListCnt, int ListSize, unsigned char *Buf,int ListMemSizeNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCMakeListeExt(CHANNEL_0, ListNum, ListCnt, ListSize, Buf, ListMemSizeNum);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCMakeListeVFExt"
//**********************************************************************************************
// TBCMakeListeVFExt
//
// Daten einer Liste in den Buffer der DLL schreiben (Variante fr feste/variable Listen)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// ListNum	-> Nummer der Liste entsprechend Listenbeschreibung im Setup (wird ab 0 gezhlt)
// ListCnt	-> Anzahl der Zeilen in der Liste
// ListSize -> Gre der Liste in Byte (ListCnt mal Byte pro Listenzeile)
// Buf		-> Buffer mit den Listendaten
// ListMemSizeNum -> Nummer die festlegt wiefiel Speicher im Timeboy fr Listen fest und variable 
//                   reserviert wird.
//					 mu mit Angabe im Setup bereinstimmen!
//				  1 -> 224kByte Listen
//				  2 -> 352kByte Listen
//				  3 -> 480kByte Listen
//				  4 -> 608kByte Listen
//				  5 -> 736kByte Listen
//				  6 -> 864kByte Listen
// ListMemSizeNumV -> Nummer die festlegt wiefiel Speicher im Timeboy fr variable Listen 
//                   reserviert wird.
//					 mu mit Angabe im Setup bereinstimmen!
//				  1 -> 128kByte Listen
//				  2 -> 256kByte Listen
//				  3 -> 384kByte Listen
//				  4 -> 512kByte Listen
//				  5 -> 640kByte Listen
//				  6 -> 768kByte Listen
//                Bedingung: ListMemSizeNumV <= ListMemSizeNum
// VarListe -> 1 -> die bergebene Liste wird in den variablen Listenbereich bernommen
//			-> 0 -> die bergebene Liste wird in den festen Listenbereich bernommen
// return	-> 1 -> Operation erfolgreich
//			-> 0 -> Fehler
extern "C" __declspec(dllexport) 

int __stdcall TBCMakeListeVFExt(int ChannelNum, int ListNum, int ListCnt, int ListSize, unsigned char *Buf,
	            int ListMemSizeNum,int ListMemSizeNumV, int VarListe)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i\t%i", FUNC_NAME, ChannelNum, ListNum, ListCnt, ListSize);

	// berprfung der Parameterwerte.
	if (!((ListNum >= 0) && (ListNum < MAX_DATENSATZ_BESCHREIBUNG)) || ((Buf == NULL) && ((ListCnt > 0) || (ListSize > 0)))) {
		
		Com->logEnd("\t\t%i\t%i\t%i\t(%i)", ListMemSizeNum, ListMemSizeNumV, VarListe, iRes);
		return iRes;
	}

	unsigned long pDat,ListStart,SizeV;
	int i;

	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCMakeListeExt ChannelNum=%04X ListNum=%04X ListCnt=%04X ListSize=%04X ListMemSizeNum=%04X ListMemSizeNumV=%04X VarList=%04X Buf=\r\n",t,ChannelNum,ListNum,ListCnt,ListSize,ListMemSizeNum,ListMemSizeNumV,VarListe);
		theApp.LogFile.Write(st,st.GetLength());
		LogWriteHex(Buf,ListSize,&(theApp.LogFile));
	}

	// Startadresse berechnen
	if(ListMemSizeNum == 1) ListStart = FLASH_LIST_START_1;
	else if(ListMemSizeNum == 2) ListStart = FLASH_LIST_START_2;
	else if(ListMemSizeNum == 3) ListStart = FLASH_LIST_START_3;
	else if(ListMemSizeNum == 4) ListStart = FLASH_LIST_START_4;
	else if(ListMemSizeNum == 5) ListStart = FLASH_LIST_START_5;
	else if(ListMemSizeNum == 6) ListStart = FLASH_LIST_START_6;
	else ListStart = FLASH_LIST_START;
	// Lnge var.-Bereich berechnen
	if (ListMemSizeNumV == 1) SizeV = 0x20000;
	else if (ListMemSizeNumV == 2) SizeV = 0x40000;
	else if (ListMemSizeNumV == 3) SizeV = 0x60000;
	else if (ListMemSizeNumV == 4) SizeV = 0x80000;
	else if (ListMemSizeNumV == 5) SizeV = 0xA0000;
	else if (ListMemSizeNumV == 6) SizeV = 0xC0000;
	else SizeV = 0x00000;

	// bei ersten aufruf der Funktion nach Start bzw. nach lschen Datenpointer init.
	if (Com->IsClrListenVF) {
		Com->LSizeV = ListStart+MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);
		// alt Com->LSizeF = ListStart+SizeV;
		Com->LSizeF = ListStart+MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG)+SizeV;
		Com->IsClrListenVF = FALSE;
		Com->Speicher = ListMemSizeNum;
		Com->SpeicherV = ListMemSizeNumV;
		for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);i++) Com->FlashMem[i+ListStart] = 0x00;
		Com->ListStartV = ListStart;
		//Com->ListStartF = Com->LSizeF; // RK27b
		Com->ListStartF = ListStart+SizeV; // RK27b Speicher fr Listen F ohne Offset
		Com->FlashMem[Com->ListStartF] = 0x00; // RK27b erstes Byte != 0xFF um lschen zu erzwingen
	}
	// Pointer in Tabelle der Listen-Pointer eintragen
	if (VarListe) {
		*(unsigned long *)(&(Com->FlashMem[ListNum*sizeof(long)+ListStart])) = Com->LSizeV;
	}else{
		*(unsigned long *)(&(Com->FlashMem[ListNum*sizeof(long)+ListStart])) = Com->LSizeF;
	}
	*(unsigned long *)(&(Com->PMaske[ListNum*sizeof(long)])) = 0; // Maske zum einfgen fest L.
	// Start fr Listendaten berechnen
	if (VarListe) {
		pDat = Com->LSizeV+sizeof(ULONG);	// Platz fr Anzahl Eintrge freihalten
	}else{
		pDat = Com->LSizeF+sizeof(ULONG);	// Platz fr Anzahl Eintrge freihalten
	}
	// Startadresse und Gre fr Listen einzeln merken
	Com->SlListStart[ListNum] = pDat-sizeof(ULONG)+ListStart;
	Com->SlListSize[ListNum] = ListSize+sizeof(ULONG)+32;
	// Listendaten kopieren
	for (i=0;i<ListSize;i++) {
		Com->FlashMem[pDat+i] = Buf[i];
	}
	// Anzahl Listenzeilen eintragen und
	// Listen-Pointer auf erstes freies Byte im Listenspeicher setzen
	if (VarListe) {
		*(unsigned long*)(&(Com->FlashMem[Com->LSizeV])) = ListCnt;
		Com->LSizeV = pDat+ListSize;
	}else{
		*(unsigned long*)(&(Com->FlashMem[Com->LSizeF])) = ListCnt;
		Com->LSizeF = pDat+ListSize;
	}

	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCMakeListeExt Exit OK\r\n",t);
		theApp.LogFile.Write(st,st.GetLength());
	}
	iRes = 1;

	/*
	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCMakeListeExt Exit Error\r\n",t);
		theApp.LogFile.Write(st,st.GetLength());
	}
	*/

	Com->logEnd("\t0x%08X\t%i\t%i\t%i\t(%i)", Buf, ListMemSizeNum, ListMemSizeNumV, VarListe, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCMakeListeVF(int ListNum, int ListCnt, int ListSize, unsigned char *Buf,
			   int ListMemSizeNum,int ListMemSizeNumV, int VarListe)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCMakeListeVFExt(CHANNEL_0, ListNum, ListCnt, ListSize, Buf, ListMemSizeNum, ListMemSizeNumV, VarListe);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadSingleListExt"
//**********************************************************************************************
// TBCLoadSingleListExt
//
// Eine Listen aus dem Buffer der DLL in den Timboy laden
// (vor dem bertragen werden alle alten Listen im Timeboy gelscht)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// ListNum	->  Nummer der Liste (entsprechend der Reihenfolge im Setup mit 0 beginnend)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadSingleListExt(int ChannelNum, int BusNum, int ListNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i\t%i", FUNC_NAME, ChannelNum, BusNum, ListNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || !((ListNum >= 0) && (ListNum < MAX_DATENSATZ_BESCHREIBUNG)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	if (Com->LSize == 0) {
		*Error = ERR_NO_LIST ;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes; // keine Listen vorhanden
	}
	Com->ChangeBusNum(BusNum);
	iRes = Com->SetListeSingle(ListNum,Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadSingleList(int BusNum, int ListNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadSingleListExt(CHANNEL_0, BusNum, ListNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadListenExt"
//**********************************************************************************************
// TBCLoadListenExt
//
// Alle Listen aus dem Buffer der DLL in den Timboy laden
// (vor dem bertragen werden alle alten Listen im Timeboy gelscht)
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadListenExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	if (Com->LSize == 0) {
		*Error = ERR_NO_LIST ;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes; // keine Listen vorhanden
	}
	Com->ChangeBusNum(BusNum);
	iRes = Com->SetListen(Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadListen(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadListenExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadListenVFExt"
//**********************************************************************************************
// TBCLoadListenVFExt
//
// Listen aus dem Buffer der DLL in den Timboy laden (Variante fr feste/variable Listen).
// Vor dem bertragen werden alte Listen im Timeboy gelscht.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// NurVarListen -> 1 -> Es werden nur die variablen Listen gelscht und neu bertragen
//				-> 0 -> Es werden alle Listen gelscht und bertragen
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadListenVFExt(int ChannelNum, int BusNum, int *Error, int NurVarListen)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, NurVarListen, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t(%i)", NurVarListen, *Error, iRes);
		return iRes;
	}

	if (Com->IsClrListenVF == 1) {
		*Error = ERR_NO_LIST ;
		Com->logEnd("\t%i\t%i\t(%i)", NurVarListen, *Error, iRes);
		return iRes; // keine Listen vorhanden
	}
	Com->ChangeBusNum(BusNum);
	iRes = Com->SetListenVF(Error,NurVarListen);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch;

	Com->logEnd("\t%i\t%i\t(%i)", NurVarListen, *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadListenVF(int BusNum, int *Error, int NurVarListen)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadListenVFExt(CHANNEL_0, BusNum, Error, NurVarListen);
}
	
#undef FUNC_NAME
#define  FUNC_NAME "TBCClrListenExt"
//**********************************************************************************************
// TBCClrListenExt
//
// Listen im Gert lschen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCClrListenExt(int ChannelNum,int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}
	Com->ChangeBusNum(BusNum);
	iRes = Com->ClrListenTb(BusNum,Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCClrListen(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCClrListenExt(CHANNEL_0,BusNum,Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCClrListenBufferExt"
//**********************************************************************************************
// TBCClrListenBufferExt
//
// Listen Daten im PC-Buffer lschen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCClrListenBufferExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCClrListenBufferExt ChannelNum=%04X\r\n",t,ChannelNum);
		theApp.LogFile.Write(st,st.GetLength());
	}

	Com->LSize = MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);
	for(int i=0;i<MAX_DATENSATZ_BESCHREIBUNG*4;i++) Com->FlashMem[i+FLASH_LIST_START] = 0;
	for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++) {
		Com->SlListStart[i] = -1;
		Com->SlListSize[i] = -1;
	}

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCClrListenBuffer()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCClrListenBufferExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCClrListenBufferVFExt"
//**********************************************************************************************
// TBCClrListenBufferVFExt
//
// Listen Daten im PC-Buffer lschen (Variante fr feste/variable Listen).
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

void __stdcall TBCClrListenBufferVFExt(int ChannelNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	if (theApp.Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sTBCClrListenBufferVFExt ChannelNum=%04X\r\n",t,ChannelNum);
		theApp.LogFile.Write(st,st.GetLength());
	}

	Com->LSize = MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);
	for(int i=0;i<MAX_DATENSATZ_BESCHREIBUNG*4;i++) Com->FlashMem[i+FLASH_LIST_START] = 0;
	Com->ClrListen();
	for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++) {
		Com->SlListStart[i] = -1;
		Com->SlListSize[i] = -1;
	}

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCClrListenBufferVF()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCClrListenBufferVFExt(CHANNEL_0);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetDateTimeExt"
//**********************************************************************************************
// TBCSetDateTimeExt
//
// Datum und Uhrzeit im Timeboy setzen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Buf		->	Zeichenfeld bestehend aus 7 Byte 
//				Byte 0 -> Jahrhunderte  (0...255)
//				Byte 1 -> Jahre einer/zehner (0...99)
//				Byte 2 -> Monat (1...12)
//				Byte 3 -> Tag (1...31)
//				Byte 4 -> Stunde (0...23)
//				Byte 5 -> Minute (0...59)
//				Byte 6 -> Sekunde (0...59)
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCSetDateTimeExt(int ChannelNum, int BusNum, int *Error, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->SetDateTime(BusNum,Error,Buf);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	if (Buf)
	{
		Com->logEnd("\t%i\t%02i%02i_%02i_%02i %02i:%02i:%02i\t(%i)", *Error,
			Buf[0],Buf[1],Buf[2],Buf[3],Buf[4],Buf[5],Buf[6], iRes);
	}
	else
	{
		Com->logEnd("\t%i\t\t(%i)", *Error, iRes);
	}

	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetDateTime(int BusNum, int *Error, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetDateTimeExt(CHANNEL_0, BusNum, Error, Buf);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetDateTimeExt"
//**********************************************************************************************
// TBCGetDateTimeExt
//
// Datum und Uhrzeit aus Timeboy auslesen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Buf		->	Zeichenfeld bestehend aus 7 Byte in welches das aktuelle 
//				Datum/Uhrzeit des Timeboy geschrieben wird
//				Byte 0 -> Jahrhunderte  (0...255)
//				Byte 1 -> Jahre einer/zehner (0...99)
//				Byte 2 -> Monat (1...12)
//				Byte 3 -> Tag (1...31)
//				Byte 4 -> Stunde (0...23)
//				Byte 5 -> Minute (0...59)
//				Byte 6 -> Sekunde (0...59)
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCGetDateTimeExt(int ChannelNum, int BusNum, int *Error, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || Buf == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetDateTime(BusNum,Error,Buf);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	if (iRes)
	{
		Com->logEnd("\t%i\t%02i%02i_%02i_%02i %02i:%02i:%02i\t(%i)", *Error,
			Buf[0],Buf[1],Buf[2],Buf[3],Buf[4],Buf[5],Buf[6], iRes);
	}
	else
	{
		Com->logEnd("\t%i\t\t(%i)", *Error, iRes);
	}
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetDateTime(int BusNum, int *Error, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCGetDateTimeExt(CHANNEL_0, BusNum, Error, Buf);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetPasswordExt"
//**********************************************************************************************
// TBCGetPasswordExt
//
// Passwort fuer Kommunikation mit Timeboy lesen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCGetPasswordExt(int ChannelNum, int BusNum,  int *Error, unsigned char *Password)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || Password == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%s\t(%i)", *Error, "*****", iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetPassword(BusNum,Error,Password);
	Com->ChangeBusNum(MB_ADD_OFFLINE);

	Com->logEnd("\t%i\t%s\t(%i)", *Error, "*****", iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetPassword(int BusNum,  int *Error, unsigned char *Password)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCGetPasswordExt(CHANNEL_0, BusNum, Error, Password);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetPasswortExt"
// unsolved: laut Setup ist Passwort 16 Byte lang !!! ??? !!!
//**********************************************************************************************
// TBCSetPasswortExt
//
// Passwort fpr Kommunikation mit Timeboy setzen
// Wenn im Setup des Timeboy ein Passwort gesetzt wurde ist dieses bei jeder Kommunikation notwendig.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// Pass  -> Zeichenkette mit Passwort max. 12 Zeichen + abschliesende 0
extern "C" __declspec(dllexport) 

void __stdcall TBCSetPasswortExt(int ChannelNum, unsigned char *Pass)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (Pass == NULL) {
		
		Com->logEnd("\t");
		return;
	}

	int i;
	CString P;

	for (i=0;i<13 && Pass[i] != 0;i++);
	if (i>12) {		// Passwort zu lang
		return;
	}
	P.Format("%s",Pass);
	Com->SetPasswort(P);

	Com->logEnd("\t%s", "*****");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetPasswort(unsigned char *Pass)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetPasswortExt(CHANNEL_0, Pass);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCAus"
//**********************************************************************************************
// TBCAus
//
// Timeboy in Dockingstation ausschalten
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCAusExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TBAus(BusNum,Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCAus(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCAusExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCMessageExt"
//**********************************************************************************************
// TBCMessageExt
//
// Message an Timeboy senden.
// max. 4 Zeilen a 12 Zeichen. Die Zeilen mussen durch '\r', '\t' oder '\n' getrennt werden
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Message  ->  Zeichenkette mit der Message.
//				max. 4 Zeilen a 12 Zeichen. 
//				Alle Zeilen mssen in einer Zeichenkette bergeben werden
//				Die Zeilen mussen durch '\r', '\t' oder '\n' getrennt werden.
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCMessageExt(int ChannelNum, int BusNum, unsigned char *Message, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Message == NULL || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%s\t%i\t(%i)", (Message != NULL) ? (char*)Message : "", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%s\t%i\t(%i)", Message, *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);

	if (! *Message)
		iRes = Com->TBMessage(BusNum, Error, (unsigned char *) "bertragung Ende                                ");
	else
		iRes = Com->TBMessage(BusNum, Error, Message);

	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;
	
	Com->logEnd("\t%s\t%i\t(%i)", Message, *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCMessage(int BusNum, unsigned char *Message, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCMessageExt(CHANNEL_0, BusNum, Message, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetMessageExt"
//**********************************************************************************************
// TBCSetMessageExt
//
// Message an Timeboy senden.
// max. 4 Zeilen a 12 Zeichen. Die Zeilen knnen durch '\r', '\t' oder '\n' getrennt werden
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Message  ->  Zeichenkette mit der Message.
//				max. 4 Zeilen a 12 Zeichen. 
//				Alle Zeilen mssen in einer Zeichenkette bergeben werden
//				Die Zeilen knnen durch '\r', '\t' oder '\n' getrennt werden.
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCSetMessageExt(int ChannelNum, int BusNum, int *Error, unsigned char *Message, int MessageIsFormatted, int SendLineByLine)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || Message == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t%s\t%i\t%i\t(%i)", ERR_FUNCTION_PARAMETER, (Message != NULL) ? (char*)Message : "", MessageIsFormatted, SendLineByLine, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%s\t%i\t%i\t(%i)", *Error, Message, MessageIsFormatted, SendLineByLine, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TBMessage(BusNum, Error, Message, MessageIsFormatted, SendLineByLine);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t%s\t%i\t%i\t(%i)", *Error, Message, MessageIsFormatted, SendLineByLine, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetMessage(int BusNum, int *Error, unsigned char *Message, int MessageIsFormatted, int SendLineByLine)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetMessageExt(CHANNEL_0, BusNum, Error, Message, MessageIsFormatted, SendLineByLine);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetGlobVarExt"
//**********************************************************************************************
// TBCSetGlobVarExt
//
// Globale Variable im Timeboy setzen.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// GlobVarS1 bis GlobVarS4 -> Globale String-Variable max. 40 Zeichen + abschliesende 0
// GlobVarI1 bis GlobVarI4 -> Globale Unsigned-Integer Variable (4Byte)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCSetGlobVarExt(int ChannelNum, int BusNum, 
					unsigned char *GlobVarS1,unsigned char *GlobVarS2,
					unsigned char *GlobVarS3,unsigned char *GlobVarS4,
					unsigned int GlobVarI1,unsigned int GlobVarI2,
					unsigned int GlobVarI3,unsigned int GlobVarI4,
					int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || 
		GlobVarS1 == NULL || GlobVarS2 == NULL || GlobVarS3 == NULL || GlobVarS4 == NULL || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%s\t%s\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t(%i)", 
			(GlobVarS1 != NULL) ? (char*)GlobVarS1 : "", 
			(GlobVarS2 != NULL) ? (char*)GlobVarS2 : "", 
			(GlobVarS3 != NULL) ? (char*)GlobVarS3 : "", 
			(GlobVarS4 != NULL) ? (char*)GlobVarS4 : "",
			GlobVarI1, GlobVarI2, GlobVarI3, GlobVarI4, 
			ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%s\t%s\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t(%i)", 
			GlobVarS1, GlobVarS2, GlobVarS3, GlobVarS4,
			GlobVarI1, GlobVarI2, GlobVarI3, GlobVarI4, 
			*Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TBSetGlobVar(BusNum,GlobVarS1,GlobVarS2,GlobVarS3,GlobVarS4,
					GlobVarI1,GlobVarI2,GlobVarI3,GlobVarI4,Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%s\t%s\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t(%i)", 
		GlobVarS1, GlobVarS2, GlobVarS3, GlobVarS4,
		GlobVarI1, GlobVarI2, GlobVarI3, GlobVarI4, 
		*Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCSetGlobVar(int BusNum, 
			  unsigned char *GlobVarS1,unsigned char *GlobVarS2,
			  unsigned char *GlobVarS3,unsigned char *GlobVarS4,
			  unsigned int GlobVarI1,unsigned int GlobVarI2,
			  unsigned int GlobVarI3,unsigned int GlobVarI4,
			  int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCSetGlobVarExt(CHANNEL_0, BusNum, GlobVarS1, GlobVarS2, GlobVarS3, GlobVarS4, GlobVarI1, GlobVarI2, GlobVarI3, GlobVarI4, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetGlobVarExt"
//**********************************************************************************************
// TBCGetGlobVarExt
//
// Globale Variable aus Timeboy lesen.
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// GlobVarS1 bis GlobVarS4 -> Globale String-Variable max. 40 Zeichen + abschliesende 0
// GlobVarI1 bis GlobVarI4 -> Globale Unsigned-Integer Variable (4Byte)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCGetGlobVarExt(int ChannelNum, int BusNum, 
					unsigned char *GlobVarS1,unsigned char *GlobVarS2,
					unsigned char *GlobVarS3,unsigned char *GlobVarS4,
					unsigned int *GlobVarI1,unsigned int *GlobVarI2,
					unsigned int *GlobVarI3,unsigned int *GlobVarI4,
					int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || 
		GlobVarS1 == NULL || GlobVarS2 == NULL || GlobVarS3 == NULL || GlobVarS4 == NULL || 
		GlobVarI1 == NULL || GlobVarI2 == NULL || GlobVarI3 == NULL || GlobVarI4 == NULL || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t\t\t\t\t\t\t\t\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%s\t%s\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t(%i)", 
			GlobVarS1, GlobVarS2, GlobVarS3, GlobVarS4,
			*GlobVarI1, *GlobVarI2, *GlobVarI3, *GlobVarI4, 
			*Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->TBGetGlobVar(BusNum,GlobVarS1,GlobVarS2,GlobVarS3,GlobVarS4,
					GlobVarI1,GlobVarI2,GlobVarI3,GlobVarI4,Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%s\t%s\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t(%i)", 
		GlobVarS1, GlobVarS2, GlobVarS3, GlobVarS4,
		*GlobVarI1, *GlobVarI2, *GlobVarI3, *GlobVarI4, 
		*Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetGlobVar(int BusNum, 
			  unsigned char *GlobVarS1,unsigned char *GlobVarS2,
			  unsigned char *GlobVarS3,unsigned char *GlobVarS4,
			  unsigned int *GlobVarI1,unsigned int *GlobVarI2,
			  unsigned int *GlobVarI3,unsigned int *GlobVarI4,
			  int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCGetGlobVarExt(CHANNEL_0, BusNum, GlobVarS1, GlobVarS2, GlobVarS3, GlobVarS4, GlobVarI1, GlobVarI2, GlobVarI3, GlobVarI4, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCSetCallBackExt"
//**********************************************************************************************
// TBCSetCallBackExt
//
// Zeiger fr Call-Back-Function bekanntgeben
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// CBFunction -> Zeiger auf eine Funktion der Applikation die einen Integer-Wert zurckgibt.
//               NULL -> Call-Back-Function abgeschaltet.
// Diese Funktion wird bei jeder Kommunikation aufgerufen.
// Wenn die Function TRUE liefert, wird die Kommunikation fortgesetzt.
// Wenn die Function FALSE liefert, wird die Kommunikation sofort abgebrochen.
// Anwendungsmgichkeiten: Fortschrittsanzeige in der Applikation realisieren;
//		der Abbruch einer langen Kummunikation (z.B. Listen Laden) ist mglich.
extern "C" __declspec(dllexport) 

void __stdcall TBCSetCallBackExt(int ChannelNum, int (*CBFunction)())
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		return;
	}
	Com->logBegin("%s\t%i\t0x%08X", FUNC_NAME, ChannelNum, CBFunction);

	Com->SetCBF(CBFunction);
	Com->Abbruch = FALSE;

	Com->logEnd("");
}

extern "C" __declspec(dllexport) 

void __stdcall TBCSetCallBack(int (*CBFunction)())
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	TBCSetCallBackExt(CHANNEL_0, CBFunction);
}


CString CDfComApp::GetAppPathName()
{
  CString strPath;
  ::GetModuleFileName(AfxGetInstanceHandle(),strPath.GetBuffer(_MAX_PATH),_MAX_PATH);
  strPath.ReleaseBuffer();        
  strPath.MakeUpper();
  int npos=strPath.ReverseFind('\\');
  npos++;                 // increment npos
  strPath=strPath.Left(npos);
  strPath.ReleaseBuffer();        
  return strPath;
}

BOOL CDfComApp::InitInstance() 
{
	WSADATA WindowsData;
	WORD    Version;
	CString Name,SuchPath,DName;
	long hFile;
    struct _finddata_t c_file;
	int i,AnzDat,Catch;
	CString LogFileName[LOG_FILE_CNT+1];
	CTime Time;

	Version = MAKEWORD(2,2);
	WSAStartup(Version, &WindowsData);

	// Datei fr Logdaten vorbereiten
	Name = GetAppPathName();
	Name += "TbComLog";
	//Log = TRUE;
	Log = FALSE;
	// Testen ob Dir. vorhanden
	if (_chdir(Name) == -1) {
		// Daten-Pfad neu anlegen
		if (_mkdir(Name) == -1) {
			// Pfad kann nicht engelegt werden.
			Log = FALSE;
		}
	}
	if (Log) {
		/* Alle Dateien im Verzeichnis ermitteln */
		SuchPath = Name + "\\*";
		i = 0;
		if((hFile = _findfirst(SuchPath, &c_file )) != -1L ) {
			if (i<=LOG_FILE_CNT && c_file.name[0] == '2' && c_file.name[1] == '0') {
				LogFileName[i] = Name + '\\';
				LogFileName[i++] += c_file.name;
			}
			while(_findnext( hFile, &c_file ) == 0 ) {
				if (i<=LOG_FILE_CNT && c_file.name[0] == '2' && c_file.name[1] == '0') {
					LogFileName[i] = Name + '\\';
					LogFileName[i++] += c_file.name;
				}
			}
			_findclose( hFile );
  		}
		AnzDat = i;	// Anzahl Dateinamen im Verzeichnis
		// Dateiname aktuelles Datum aufbauen
		Time = CTime::GetCurrentTime();
		DName.Format("%s\\%04d_%02d_%02d_TbComDll.log",Name,Time.GetYear(),Time.GetMonth(),Time.GetDay());
		// Ist Datei schon vorhanden?
		Catch = -1;
		for (i=0;i<AnzDat;i++) {
			if (DName == LogFileName[i]) {
				Catch = i;
				i = AnzDat;
			}
		}
		if (Catch >= 0) {
			// ja -> Datei ffnen
			if (!LogFile.Open(LogFileName[Catch],CFile::shareDenyNone|CFile::modeCreate|CFile::modeNoTruncate|CFile::modeReadWrite)) {
				// Datei kann nicht geffnet werden
				Log = FALSE;
			}
			LogFile.SeekToEnd();
		}else{
			// nein -> ewentuell lteste Datei lschen und Datei neu anlegen
			if (AnzDat >= LOG_FILE_CNT) {
				// lteste Datei lschen
				Catch = 0;
				for (i=1;i<AnzDat;i++) {
					if (strcmp(LogFileName[Catch],LogFileName[i]) > 0) {
						Catch = i;
					}
				}
				CFile::Remove(LogFileName[Catch]);
			}
			// Datei neu anlegen
			if (!LogFile.Open(DName,CFile::shareDenyNone|CFile::modeCreate|CFile::modeNoTruncate|CFile::modeReadWrite)) {
				// Datei kann nicht geffnet werden
				Log = FALSE;
			}
			LogFile.SeekToEnd();
		}
	}
	

	return CWinApp::InitInstance();
}

int CDfComApp::ExitInstance() 
{
	WSACleanup();
	if (Log) {
		LogFile.Close();
	}

	return CWinApp::ExitInstance();
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCGetSeriennummerExt"
//**********************************************************************************************
// TBCGetSeriennummerExt
//
// Seriennummer aus Timeboy auslesen
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// SerNum	->	Seriennummer des Timeboy 
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) 

int __stdcall TBCGetSeriennummerExt(int ChannelNum, int BusNum, int *Error, int *SerNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || SerNum == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetSerienNum(BusNum,Error,SerNum);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t%i\t(%i)", *Error, *SerNum, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCGetSeriennummer(int BusNum, int *Error, int *SerNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCGetSeriennummerExt(CHANNEL_0, BusNum, Error, SerNum);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCLoadDatensatzOnlineExt"
//**********************************************************************************************
// TBCLoadDatensatzOnlineExt
//
// Einen Online Datensatz aus Timeboy auslesen
// Die Funktion liefert immer den ltesten Datensatz im Gert.
// Der Datensatz wird im Gert nicht automatisch gelscht. Weitere Aufrufe der Funktion liefern daher immer
// den gleichen Datensatz. Erst Durch Aufruf von "TBCClrDatensatzOnline" wird der Datensatz gelscht und ein 
// weiterer Aufruf der Funktion liefert dann den zweitltesten Datensatz.
// 
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				2 -> Operation erfolgreich; es wurde der letzte Datensatz gelesen
//				0 -> Fehler (Fehlernummer in Error)
//  Bei Fehlerfreier Ausfhrung werden folgende Daten von der Funktion geliefert:
// DatLen	->  Lnge des Datensatzes in Byte (DatLen = 0 -> keine Daten im Timeboy vorhanden)
// DatBeschreibungNum -> Nummer der Datensatzbeschreibung entsprechend Setup (Siehe auch "TBCDatBeschreibungNum")
// Buf		->  Daten des Datensatzes (die ersten "DatLen"-Bytes im Buffer sind die Daten) 
extern "C" __declspec(dllexport) 

int __stdcall TBCLoadDatensatzOnlineExt(int ChannelNum, int BusNum, int *Error, int *DatLen, int *DatBeschreibungNum, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL || DatLen == NULL || DatBeschreibungNum == NULL || Buf == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t\t\t\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t%i\t%i\t0x%08X\t(%i)", *Error, *DatLen, *DatBeschreibungNum, Buf, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->GetDatenOnline(Error, DatLen, DatBeschreibungNum, Buf);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	if (iRes)
	{	
		// Daten in Puffer uebergeben
		unsigned char ucTmp[512 * 3 + 1];
		int i, len = *DatLen;
		
		for (i=0; i < len; i++) {
			
			sprintf((char*)&ucTmp[i * 3], "%02X ", (unsigned char)Buf[i]);
		}
		ucTmp[i * 3] = 0;
		
		Com->logEnd("\t%i\t%i\t%i\t%s\t(%i)", *Error, *DatLen, *DatBeschreibungNum, ucTmp, iRes);
	}
	else
	{
		Com->logEnd("\t%i\t%i\t%i\t\t(%i)", *Error, *DatLen, *DatBeschreibungNum, iRes);
	}



	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCLoadDatensatzOnline(int BusNum, int *Error, int *DatLen, int *DatBeschreibungNum, unsigned char *Buf)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCLoadDatensatzOnlineExt(CHANNEL_0, BusNum, Error, DatLen, DatBeschreibungNum, Buf);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCClrDatensatzOnlineExt"
//**********************************************************************************************
// TBCClrDatensatzOnlineExt
//
// ChannelNum -> Gibt die zu verwendende Kanalnummer an.
extern "C" __declspec(dllexport) 

int __stdcall TBCClrDatensatzOnlineExt(int ChannelNum, int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	// Zeiger auf Standard - Kanalobjekt
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i\t%i", FUNC_NAME, ChannelNum, BusNum);

	// berprfung der Parameterwerte.
	if (!((BusNum >= 1) && (BusNum <= MB_ADD_OFFLINE)) || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%i\t(%i)", ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t%i\t(%i)", *Error, iRes);
		return iRes;
	}

	Com->ChangeBusNum(BusNum);
	iRes = Com->ClrDatenOnline(Error);
	Com->ChangeBusNum(MB_ADD_OFFLINE);
	Com->Abbruch = FALSE;

	Com->logEnd("\t%i\t(%i)", *Error, iRes);
	return iRes;
}

extern "C" __declspec(dllexport) 

int __stdcall TBCClrDatensatzOnline(int BusNum, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	return TBCClrDatensatzOnlineExt(CHANNEL_0, BusNum, Error);
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCWriteExt"
//**********************************************************************************************
// TBCWriteExt
//
extern "C" __declspec(dllexport)

int __stdcall TBCWriteExt(int ChannelNum, char *Buf, int Length, int *WriteLength, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (Buf == NULL || WriteLength == NULL || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t%s\t%i\t\t%i\t(%i)", (Buf != NULL) ? Buf : "", Length, ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	*Error = ERR_NO;

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t0x%08X\t%i\t%i\t%i\t(%i)", Buf, Length, *WriteLength, *Error, iRes);
		return iRes;
	}

	iRes = Com->ComWrite(Buf, Length, (unsigned long*)WriteLength);
	
	Com->logEnd("\t0x%08X\t%i\t%i\t%i\t(%i)", Buf, Length, *WriteLength, *Error, iRes);
	return iRes;
}

#undef FUNC_NAME
#define  FUNC_NAME "TBCReadExt"
//**********************************************************************************************
// TBCReadExt
//
extern "C" __declspec(dllexport)

int __stdcall TBCReadExt(int ChannelNum, char *Buf, int Length, int *ReadLength, int *Error)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int iRes = 0;
	CCom *Com = theApp.GetCom(ChannelNum);
	// Wurde Channel-Objekt ermittelt.
	if (Com == NULL) {
		
		if (Error) *Error = ERR_CHANNEL;
		return iRes;
	}
	Com->logBegin("%s\t%i", FUNC_NAME, ChannelNum);

	// berprfung der Parameterwerte.
	if (Buf == NULL || ReadLength == NULL || Error == NULL) {
		
		if (Error) *Error = ERR_FUNCTION_PARAMETER;
		Com->logEnd("\t\t%i\t\t%i\t(%i)", Length, ERR_FUNCTION_PARAMETER, iRes);
		return iRes;
	}

	*Error = ERR_NO;

	// Schnittstelle geoeffnet?
	if (!Com->IsOpen()) {

		*Error = ERR_NO_COM;
		Com->logEnd("\t0x%08X\t%i\t%i\t%i\t(%i)", Buf, Length, *ReadLength, *Error, iRes);
		return iRes;
	}

	iRes = Com->ComRead(Buf, Length, (unsigned long*)ReadLength);

	
	Com->logEnd("\t0x%08X\t%i\t%i\t%i\t(%i)", Buf, Length, *ReadLength, *Error, iRes);
	return iRes;
}

#ifdef _WIN32
// DllGetVersion
#include "shlwapi.h"
// ########################################################
/** 
 * @fn    CALLBACK DllGetVersion(DLLVERSIONINFO *pdvi)
 * @brief Ermitteln der DLL - Version. Kompatible zu Windows - Standard.
 *  
 * @param pdvi       { Zeiger auf Struktur zur Informationsuebergabe. }
 */
extern "C" HRESULT PASCAL EXPORT CALLBACK DllGetVersion(DLLVERSIONINFO *pdvi)
{
	char szModuleName[MAX_PATH];
	DWORD dwHandle;
	DWORD dwLen;
	LPVOID lpBuffer = NULL;
	UINT uiLen;

	unsigned char *pucData = NULL;

	// zulaessige Bereiche pruefen
	if (pdvi == NULL) {

		return E_ABORT;
	}

	if (pdvi->cbSize != sizeof(DLLVERSIONINFO)) {
	
		return E_ABORT;
	}
	// Modulname der DLL
	if (!GetModuleFileName(theApp.m_hInstance, szModuleName, MAX_PATH)) {
	
		return E_ABORT;
	}
	// Laenge der Version - Resource
	dwLen = GetFileVersionInfoSize(szModuleName, &dwHandle);
	if (!dwLen) {
	
		return E_ABORT;
	}

	pucData = new unsigned char[dwLen + 100]; // unicode
	// DLL - Versioninfo ermitteln
	if (!GetFileVersionInfo(szModuleName, dwHandle, dwLen, (LPVOID)pucData)) {
	
		delete pucData;
		return E_ABORT;
	}
	// Pointer auf allgemeine Infostruktur ermitteln
	if (!VerQueryValue((LPVOID)pucData, "\\\0", &lpBuffer, &uiLen)) {

		delete pucData;
		return E_ABORT;
	}
	// Daten zurueckgeben
	VS_FIXEDFILEINFO *pvs_ffi = (VS_FIXEDFILEINFO*)lpBuffer;
	pdvi->dwMajorVersion = pvs_ffi->dwFileVersionMS >> 16;
	pdvi->dwMinorVersion = pvs_ffi->dwFileVersionMS & 0x0000FFFF;
	pdvi->dwBuildNumber  = pvs_ffi->dwFileVersionLS >> 16;
	pdvi->dwPlatformID   = DLLVER_PLATFORM_WINDOWS;

	delete pucData;

	return NOERROR;
}
#endif

